package com.spectus.iap.spectus_in_app_purchase

import android.app.Activity
import android.content.Context
import android.util.Log
import com.android.billingclient.api.*


class IAPHelper {


    //SKU Details param
    var billingClient_SKU: BillingClient? = null
    var productIDs_SKU: List<String> = listOf()
    var context_SKU: Context? = null
    var mActivity_SKU: Activity? = null

    // Product Purchases param
    var context: Context? = null
    var productId: String = ""
    var isSubscription: Boolean = false
    var billingClient: BillingClient? = null
    var mActivity_PRODUCT: Activity? = null

    var skuProductDetails: SkuDetails? = null
    var storedProductDataList: ArrayList<SkuDetails> = ArrayList()
    val productDetail: HashMap<String, String> = HashMap()
    var productList: ArrayList<Map<String, String>> = arrayListOf()
    var purchaseDataSuccess = PurchaseData()

    var purchaseCallBack: ((errorMessage: String?, purchaseObject: Purchase?, purchaseID: String?) -> Unit)? =
            null
    var skuDataListCallBack: ((errorMessage: String?, skuDetails: String?) -> Unit)? =
            null

    fun startInAppPurchaseWith(
            mActivityObj: Activity,
            contextObj: Context,
            productIdentifier: String,
            isSubscription: Boolean,
            callbackproduct: (errorMessage: String?, purchaseObject: Purchase?, purchaseID: String?) -> Unit
    ) {
        print("==>> startInAppPurchaseWith")
        productId = productIdentifier
        context = contextObj
        mActivity_PRODUCT = mActivityObj
        purchaseCallBack = callbackproduct
        skuDataListCallBack = null
        this.isSubscription = isSubscription

        billingClient = null
        this.setUpBillingClient(contextObj)
    }

    fun getSKUProductListWith(
            mActivityObj: Activity,
            contextObj: Context,
            productIdentifier: List<String>,
//        productIdentifier: String,
            isSubscription: Boolean,
            callback: ((errorMessage: String?, skuDetails: String?) -> Unit)
    ) {
        Log.v("=>getSKUProductListWith", "")
        productIDs_SKU = productIdentifier
        context_SKU = contextObj
        mActivity_SKU = mActivityObj
        skuDataListCallBack = callback
        purchaseCallBack = null
        this.isSubscription = isSubscription

        if (skuDataListCallBack == null) {
            Log.v("Callback null ", "")
        } else {
            Log.v("Callback not null ", "")
        }

        billingClient_SKU = null
        this.setUpBillingClient_SKU(contextObj)
    }

    fun setUpBillingClient_SKU(context: Context) {
        // do your stuff
        billingClient_SKU = BillingClient.newBuilder(context)
                .setListener(purchaseUpdateListenerSKU)
                .enablePendingPurchases()
                .build()
        this.startConnection_SKU(context)
    }

    fun startConnection_SKU(context: Context) {
        billingClient_SKU?.startConnection(object : BillingClientStateListener {
            override fun onBillingSetupFinished(billingResult: BillingResult) {
                if (billingResult.responseCode == BillingClient.BillingResponseCode.OK) {
                    // The BillingClient is ready. You can query purchases here.
                    Log.v("TAG_INAPP", "Setup Billing Done")
                    queryAvaliableSKU(context)
                }
            }

            override fun onBillingServiceDisconnected() {

            }
        })
    }

    fun queryAvaliableSKU(context: Context) {
        Log.v("TAG_INAPP productId", "" + productId)
        var skuList = listOf(productId)

        if (productIDs_SKU.size > 0) {
            skuList = productIDs_SKU
        }

        var skuType  =  BillingClient.SkuType.INAPP
        if (isSubscription) {
            skuType = BillingClient.SkuType.SUBS
        }

        val params = SkuDetailsParams.newBuilder()
                .setSkusList(skuList)
                .setType(skuType)
                .build()

        billingClient_SKU?.querySkuDetailsAsync(params) { billingResult, skuDetailsList
            ->
            Log.e("INSIDE", "" + skuDetailsList!!.size.toString())
            Log.e("RESULT Code => ", "" + billingResult.responseCode.toString())
            // Process the result.
            if (billingResult.responseCode == BillingClient.BillingResponseCode.OK && !skuDetailsList.isNullOrEmpty()) {
                storedProductDataList.clear()
                storedProductDataList.addAll(skuDetailsList)

                var details: String = ""
                var counter = 0
                for (skuDetails in skuDetailsList) {
                    counter++
                    Log.v("TAG_INAPP", "skuDetailsList : ${skuDetailsList}")
                    //This list should contain the products added above
                    if (context != null) {
                        Log.e("context not null", "context not null")
                    } else {
                        Log.e("context null", "context null")
                    }


                    val product: MutableMap<String, String> = HashMap()
                    product["currency"] = skuDetails.priceCurrencyCode
                    product["amount"] = skuDetails.price
                    product["title"] = skuDetails.title
                    product["description"] = skuDetails.description
                    product["productID"] = skuDetails.sku

                    productList.add(product)

                    var productTitle: String = skuDetails.title
                    val index = productTitle.indexOf(" (")
                    if (index != -1) {
                        productTitle = productTitle.substring(0, index)
                    }

                    if (!details.isEmpty()) {
                        val sb = StringBuilder()

                        var info = skuDetails.price + "&&" + skuDetails.priceCurrencyCode +
                                "&&" + productTitle +
                                "&&" + skuDetails.description +
                                "&&" + skuDetails.sku

                        sb.append(details).append("&^&").append(info)
                        details = sb.toString()

                    } else {
                        details = skuDetails.price + "&&" + skuDetails.priceCurrencyCode +
                                "&&" + productTitle +
                                "&&" + skuDetails.description +
                                "&&" + skuDetails.sku
                    }


                    if (counter == skuDetailsList.size) {
                        if (skuDataListCallBack != null) {
                            Log.e("Inside CALLBACK", "")
                            Log.e("Inside CALLBACK Count", "" + productList.size.toString())
                            skuDataListCallBack!!(null, details)
                            skuDataListCallBack = null
                        } else {
                            Log.e("CALLBACK null", "")
                        }
                    }

                }
            }
        }
    }

    fun setUpBillingClient(context: Context) {
        // do your stuff
        billingClient = BillingClient.newBuilder(context)
                    .enablePendingPurchases()
                    .setListener(purchaseUpdateListener)
                    .build()
        this.startConnection(context)
    }


    fun startConnection(context: Context) {
        billingClient?.startConnection(object : BillingClientStateListener {
            override fun onBillingSetupFinished(billingResult: BillingResult) {
                if (billingResult.responseCode == BillingClient.BillingResponseCode.OK) {
                    // The BillingClient is ready. You can query purchases here.
                    Log.v("TAG_INAPP", "Setup Billing Done")
                    queryAvaliableProducts(context)
                }
            }

            override fun onBillingServiceDisconnected() {

            }
        })
    }

    fun queryAvaliableProducts(context: Context) {
        Log.v("TAG_INAPP productId", "" + productId)
        var skuList = listOf(productId)

/*
        if (productIDs.size > 0) {
            skuList = productIDs
        }
*/

        var skuType  =  BillingClient.SkuType.INAPP
        if (isSubscription) {
            skuType = BillingClient.SkuType.SUBS
        }

        val params = SkuDetailsParams.newBuilder()
                .setSkusList(skuList)
                .setType(skuType)
                .build()

        billingClient?.querySkuDetailsAsync(params) { billingResult, skuDetailsList
            ->
            Log.e("INSIDE", "" + skuDetailsList!!.size.toString())
            Log.e("RESULT Code => ", "" + billingResult.responseCode.toString())
            // Process the result.
            if (billingResult.responseCode == BillingClient.BillingResponseCode.OK && !skuDetailsList.isNullOrEmpty()) {
                storedProductDataList.clear()
                storedProductDataList.addAll(skuDetailsList)

                var details: String = ""
                var counter = 0
                for (skuDetails in skuDetailsList) {
                    counter++
                    Log.v("TAG_INAPP", "skuDetailsList : ${skuDetailsList}")
                    //This list should contain the products added above
                    if (context != null) {
                        Log.e("context not null", "context not null")
                    } else {
                        Log.e("context null", "context null")
                    }


                    val product: MutableMap<String, String> = HashMap()
                    product["currency"] = skuDetails.priceCurrencyCode
                    product["amount"] = skuDetails.price
                    product["title"] = skuDetails.title
                    product["description"] = skuDetails.description
                    product["productID"] = skuDetails.sku

                    productList.add(product)

                    var productTitle: String = skuDetails.title
                    val index = productTitle.indexOf(" (")
                    if (index != -1) {
                        productTitle = productTitle.substring(0, index)
                    }

                    if (!details.isEmpty()) {
                        val sb = StringBuilder()

                        var info = skuDetails.price + "&&" + skuDetails.priceCurrencyCode +
                                "&&" + productTitle +
                                "&&" + skuDetails.description +
                                "&&" + skuDetails.sku

                        sb.append(details).append("&^&").append(info)
                        details = sb.toString()

                    } else {
                        details = skuDetails.price + "&&" + skuDetails.priceCurrencyCode +
                                "&&" + productTitle +
                                "&&" + skuDetails.description +
                                "&&" + skuDetails.sku
                    }

                    if (counter == skuDetailsList.size) {
                        updateUI(skuDetails, context)
                    }

                }
            }
        }
    }

    fun updateUI(skuDetails: SkuDetails?, context: Context) {
        skuDetails?.let {
            this.skuProductDetails = it
        }
        Log.e("herer null", "geterer null")
        skuProductDetails?.let {
            val billingFlowParams = BillingFlowParams.newBuilder()
                    .setSkuDetails(it)
                    .build()
            Log.e("billingFlowParams", "" + billingFlowParams)

            if (mActivity_PRODUCT != null) {
                Log.e("act not null", "act not null")
            } else {
                Log.e("act  null", "act  null")
            }
            billingClient?.launchBillingFlow(mActivity_PRODUCT!!, billingFlowParams)?.responseCode
        } ?: noSKUMessage()

    }

    private fun noSKUMessage() {
        Log.e("no sku msg", "no sku msg")
    }

    val purchaseUpdateListener = PurchasesUpdatedListener { billingResult, purchases ->
        Log.v("TAG_INAPP", "billingResult responseCode : ${billingResult.responseCode}")
        if (billingResult.responseCode == Constant.OK && purchases != null) {
            var purchaseData: Purchase? = null
            for (purchase in purchases) {
                purchaseData = purchase
            }

            if (this.isSubscription) {
                handleNonConcumablePurchase(purchaseData!!)
            } else {
                handleConsumedPurchases(purchaseData!!)
            }
        } else if (billingResult.responseCode != null) {
            Log.v("TAG_INAPP", "billingResult responseCode Other Than OK : ${billingResult.responseCode}")
            if (purchaseCallBack != null) {
                purchaseCallBack!!(billingResult.responseCode.toString(), null, null)
            }
        }
        /*else if (billingResult.responseCode == Constant.USER_CANCELED) {
            storedErrorData("User cancel the process.")
        } else if (billingResult.responseCode == Constant.SERVICE_UNAVAILABLE) {
            storedErrorData("Service is unavailable.")
        } else if (billingResult.responseCode == Constant.BILLING_UNAVAILABLE) {
            storedErrorData("Billing is unavailable.")
        } else if (billingResult.responseCode == Constant.ITEM_UNAVAILABLE) {
            storedErrorData("Item is unavailable.")
        } else if (billingResult.responseCode == Constant.DEVELOPER_ERROR) {
            storedErrorData("Deleloper Error.")
        } else if (billingResult.responseCode == Constant.ERROR) {
//            storedErrorData("Somthing went wrong.")
        } else if (billingResult.responseCode == Constant.ITEM_ALREADY_OWNED) {
            if (purchaseCallBack != null) {
                purchaseCallBack!!(billingResult.responseCode.toString(), null, null)
            }
//            storedErrorData("Item already owned.")
        } else if (billingResult.responseCode == Constant.ITEM_NOT_OWNED) {
            storedErrorData("Somthing went wrong.")
        } else if (billingResult.responseCode == Constant.SERVICE_TIMEOUT) {
            storedErrorData("Serverl timeout error.")
        } else if (billingResult.responseCode == Constant.FEATURE_NOT_SUPPORTED) {
            storedErrorData("Feature not supported.")
        } else if (billingResult.responseCode == Constant.SERVICE_DISCONNECTED) {
            storedErrorData("Server is disconnected.")
        }*/ else {
            // Handle any other error codes.
            Log.v("TAG_INAPP", "billingResult responseCode Not Matched : ${billingResult.responseCode}")
        }
    }

    val purchaseUpdateListenerSKU = PurchasesUpdatedListener { billingResult, purchases ->
        Log.v("TAG_INAPP", "billingResult responseCode : ${billingResult.responseCode}")


    }

    private fun handleConsumedPurchases(purchase: Purchase) {
        Log.d("TAG_INAPP", "handleConsumablePurchasesAsync foreach it is $purchase")
        var purchaseData = PurchaseData()
        purchaseData.orderId = purchase.orderId
        purchaseData.packageName = purchase.packageName
        purchaseData.purchaseTime = purchase.purchaseTime
        purchaseData.purchaseState = purchase.purchaseState
        purchaseData.developerPayload = purchase.developerPayload
        purchaseData.purchaseToken = purchase.purchaseToken
        purchaseData.autoRenewing = purchase.isAutoRenewing
        purchaseData.error_message = ""

        purchaseDataSuccess = purchaseData


        val params =
                ConsumeParams.newBuilder().setPurchaseToken(purchase.purchaseToken).build()
        billingClient?.consumeAsync(params) { billingResult, purchaseToken ->
            when (billingResult.responseCode) {
                Constant.OK -> {
                    // Update the appropriate tables/databases to grant user the items
                    var orderID = purchaseData.orderId
                    Log.e("Callback of Transaction", "Success => " + orderID!!)


                    if (purchaseCallBack != null && skuDataListCallBack == null)
                        purchaseCallBack!!(null, purchase, orderID)

                }
            }
        }
    }

    private fun handleNonConcumablePurchase(purchase: Purchase) {
        Log.v("TAG_INAPP", "handlePurchase : ${purchase}")
        if (purchase.purchaseState == Purchase.PurchaseState.PURCHASED) {
            if (!purchase.isAcknowledged) {
                val acknowledgePurchaseParams = AcknowledgePurchaseParams.newBuilder()
                    .setPurchaseToken(purchase.purchaseToken).build()
                billingClient?.acknowledgePurchase(acknowledgePurchaseParams) { billingResult ->

                    when (billingResult.responseCode) {
                        Constant.OK -> {
                            // Update the appropriate tables/databases to grant user the items
                            var orderID = purchase.orderId
                            Log.e("Callback of Transaction", "Success => " + orderID!!)

                            if (purchaseCallBack != null && skuDataListCallBack == null)
                                purchaseCallBack!!(null, purchase, orderID)

                        }
                    }

                    val billingResponseCode = billingResult.responseCode
                    val billingDebugMessage = billingResult.debugMessage
                    Log.v("TAG_INAPP", "response code: $billingResponseCode")
                    Log.v("TAG_INAPP", "debugMessage : $billingDebugMessage")
                }
            }
        }
    }

    fun storedErrorData(errorMsg: String) {
        val purchaseData = PurchaseData()
        purchaseData.orderId = ""
        purchaseData.packageName = ""
        purchaseData.purchaseTime = 0
        purchaseData.purchaseState = 0
        purchaseData.developerPayload = ""
        purchaseData.purchaseToken = ""
        purchaseData.autoRenewing = false
        purchaseData.error_message = errorMsg

        purchaseDataSuccess = purchaseData

        Log.e("Callback of Error", "=> " + errorMsg)
/*
        if (purchaseCallBack != null) {
            purchaseCallBack!!(errorMsg, null, null)
        }
*//*
    }*/
    }

    class PurchaseData {
        var orderId: String? = ""
        var packageName: String? = ""
        var productId: String? = ""
        var purchaseTime: Long = 0
        var purchaseState = 0
        var developerPayload: String? = ""
        var purchaseToken: String? = ""
        var error_message: String? = ""
        var autoRenewing = false
    }

    class Constant {

        companion object {

            // App Product ID from Play Console
            var PRODUCT_ID = "com.monthly.inapp"
            var PRODUCT_ID_2 = "data_value_product"

            /*
     * Result code of BillingClient*/
            //Success

            // Codes for Billiing Details
            var SERVICE_TIMEOUT = -3
            var FEATURE_NOT_SUPPORTED = -2
            var SERVICE_DISCONNECTED = -1
            var OK = 0
            var USER_CANCELED = 1
            var SERVICE_UNAVAILABLE = 2
            var BILLING_UNAVAILABLE = 3
            var ITEM_UNAVAILABLE = 4
            var DEVELOPER_ERROR = 5
            var ERROR = 6
            var ITEM_ALREADY_OWNED = 7
            var ITEM_NOT_OWNED = 8

        }

    }
}